`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date: 2021/04/08 13:54:03
// Design Name: 
// Module Name: down_counter
// Project Name: 
// Target Devices: 
// Tool Versions: 
// Description: 
// 
// Dependencies: 
// 
// Revision:
// Revision 0.01 - File Created
// Additional Comments:
// 
//////////////////////////////////////////////////////////////////////////////////


module down_counter(
    output reg [3:0] out1,
    output reg [3:0] out2,
    output reg LED_ctl,
    input reset,
    input count_en,
    input clk,
    input rst_n
    );
    reg [3:0] cnt1_tmp1;
    reg [3:0] cnt1_tmp2;
    reg [3:0] cnt1_tmp3;
    reg [3:0] cnt2_tmp1;
    reg [3:0] cnt2_tmp2;
    reg [3:0] cnt2_tmp3;
    reg borrow;
    
    always@*
    begin
        cnt1_tmp1 = out1;
        cnt1_tmp2 = out1 - 1'b1;
        cnt2_tmp1 = out2;
        cnt2_tmp2 = out2 - 1'b1;
    end
    
    always@*
    if(out1 == 4'b0000 && out2 == 4'b0000)
        LED_ctl = 1'b1;
    else
        LED_ctl = 1'b0;
        
    always@*
    if(reset == 0)
        if(out1 == 4'b0000 && count_en)
        begin
            if(out2 == 4'b0000)
            begin
                cnt1_tmp3 = 4'b0000;
                borrow = 1'b0;
            end
            else
            begin
                cnt1_tmp3 = 4'b1001;
                borrow = 1'b1;
            end
        end
        else if(count_en)
        begin
            cnt1_tmp3 = cnt1_tmp2;
            borrow = 1'b0;
        end
        else
        begin
            cnt1_tmp3 = cnt1_tmp1;
            borrow = 1'b0;
        end
    else
    begin
        cnt1_tmp3 = 4'b0101;
        borrow = 1'b0;
    end
    
    always@*
    if(reset == 0)
        if((borrow & (out2 == 4'b0000)))
            cnt2_tmp3 = 4'b0000;
        else if(borrow)
            cnt2_tmp3 = cnt2_tmp2;
        else
            cnt2_tmp3 = cnt2_tmp1;
    else
        cnt2_tmp3 = 4'b0010;
   
    always@(posedge clk or negedge rst_n)
    if(~rst_n)
    begin
        out1<=4'b0101;
        out2<=4'b0010;
    end    
    else
    begin
        out1<=cnt1_tmp3;
        out2<=cnt2_tmp3;
    end
    
endmodule
