`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date: 2021/04/08 16:25:44
// Design Name: 
// Module Name: top_module
// Project Name: 
// Target Devices: 
// Tool Versions: 
// Description: 
// 
// Dependencies: 
// 
// Revision:
// Revision 0.01 - File Created
// Additional Comments:
// 
//////////////////////////////////////////////////////////////////////////////////


module top_module(
    input clk,
    input rst_n,
    input button,
    output [7:0] segs,
    output [3:0] ssd_ctl,
    output [15:0] LED
    );
    wire scan_ctl;
    wire clk_1Hz;
    wire clk_4Hz;
    wire clk_100Hz;
    wire LED_ctl;
    wire [3:0] out1;
    wire [3:0] out2;
    wire count_en;
    wire pb_de;
    wire pb_re;
    wire one_pulse;
    wire state;
    wire [3:0] ssd_in;
    
    freqdiv U0(.clk(clk),.rst_n(rst_n),.scan_ctl(scan_ctl),.clk_out(clk_1Hz),.clk_4Hz(clk_4Hz),.clk_100Hz(clk_100Hz));
    down_counter U1(.clk(clk_1Hz),.rst_n(rst_n),.count_en(count_en),.reset(pb_re),.out1(out1),.out2(out2),.LED_ctl(LED_ctl));
    debounce U2(.clk(clk_100Hz),.rst_n(rst_n),.pb_in(button),.pb_de(pb_de));
    reset U3(.clk(clk_4Hz),.rst_n(rst_n),.pb_in(button),.pb_re(pb_re));
    pulse U4(.clk(clk_100Hz),.rst_n(rst_n),.pb_de(pb_de),.one_pulse(one_pulse));
    fsm U5(.clk(clk_100Hz),.rst_n(rst_n),.signal(one_pulse),.count_en(count_en),.state(state));
    scan_ctl U6(.out1(out1),.out2(out2),.ssd_ctl_en(scan_ctl),.ssd_ctl(ssd_ctl),.ssd_in(ssd_in));
    display U7(.i(ssd_in),.D(segs));
    LED U8(.state(state),.LED_ctl(LED_ctl),.led(LED));
    
endmodule
